#include <bits/stdc++.h>
#define mp make_pair
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define xx first
#define yy second
#define srt(a) sort(a.begin(),a.end());
#define srtg(a,int) sort(a.begin(),a.end(),greater<int>())
#define lb(a,x) lower_bound(a.begin(),a.end(),x)
#define up(a,x) upper_bound(a.begin(),a.end(),x)
#define fnd(a,x) find(a.begin(),a.end(),x)
#define vstart auto startt=chrono::system_clock::now()
#define vend auto endd=chrono::system_clock::now()
#define vvreme chrono::duration<double> vremee=endd-startt
#define ios ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

typedef long long ll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef string str;

const ll mod=1e9+7;

ll mul(ll a,ll b){
    if(a*b>=mod) return a*b%mod;
    return a*b;
}

ll pwr(ll a,ll b){
    ll ret=1;
    while(b>0){
        if(b&1) ret=mul(ret,a);
        b=(b>>1);
        a=mul(a,a);
    }
    return ret;
}

void solve(){
    ll n,k;
    cin>>n>>k;
    ll res=0;
    for(int i=0;i<n;i++){
        ll a;
        cin>>a;
        res+=a*mul(pwr(i+1,k),pwr(n-i,k));
    }
    cout<<res;
}

int main(){
    ios;
    int t=1;
    //cin>>t;
    while(t--) solve();
    return 0;
}